var updateListPosition = function(scrollTop, list) {
    for (var i = 0; i < list.length; i++) {
        if (list[i].speed !== 1) {
            var top = ((1 - (1 - list[i].speed)) * scrollTop).toFixed(2);
            list[i].ele.style.transform = "translate3d(0px, -" + top + "px, 0px)";
            list[i].ele.style.position = "fixed";
        }

    }
};

var formateConfigList = function(list) {
    var resList = [];
    for (var i = 0; i < list.length; i++) {
        var ele = document.getElementById(list[i].id);
        if (ele && list[i].speed) {
            resList.push({
                ele: ele,
                speed: list[i].speed
            });
            if (list[i].speed !== 1) {
                ele.style.transform = "translate3d(0px, 0px, 0px)";
            }
        }
    }
    return resList;
};


window.init = function(configList) {
    var saveScrollFn = null;
    if (window.onscroll) {
        saveScrollFn = window.onscroll;
    }

    var realConfigList = formateConfigList(configList);

    var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
    updateListPosition(scrollTop, realConfigList);

    window.onscroll = function() {
        var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        updateListPosition(scrollTop, realConfigList);
        saveScrollFn && saveScrollFn instanceof Function ? saveScrollFn() : "";
    };
};