var updateListPosition = function(scrollTop, list) {
    for (var i = 0; i < list.length; i++) {
        // 放慢速度不足1的元素
        var top = (1 - list[i].speed) * scrollTop;
        list[i].ele.style.transform = "translate3d(0px, " + top + "px, 0px)";
    }
};

var formateConfigList = function(list) {
    var resList = [];
    if (list && Object.prototype.toString.call(list) === '[object Array]') {
        for (var i = 0; i < list.length; i++) {
            // 检测一下这个元素是不是空，看看配置齐不齐，不齐就不设置
            var ele = document.getElementById(list[i].id);
            if (ele && list[i].speed) {
                resList.push({
                    ele: ele,
                    speed: list[i].speed
                });
            }
        }
    }

    return resList;
};


var init = function(configList) {
    var saveScrollFn = null;
    // 判断一下原来有没有已经设好的scroll监听事件
    if (window.onscroll) {
        saveScrollFn = window.onscroll;
    }

    // 格式化列表获取元素并保存
    var realConfigList = formateConfigList(configList);

    window.onscroll = function() {
        // 获取滚动距离
        var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        // 更新滚动距离
        updateListPosition(scrollTop, realConfigList);
        // 执行原来的事件
        saveScrollFn && saveScrollFn instanceof Function ? saveScrollFn() : "";
    };
};

module.exports = {
    init: init
};